"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chunkList = exports.sleep = exports.uniqBy = void 0;
/* eslint-disable @typescript-eslint/no-explicit-any */
function uniqBy(arr, predicate) {
    const cb = typeof predicate === 'function' ? predicate : (o) => o[predicate];
    const result = [];
    const map = new Map();
    arr.forEach((item) => {
        const key = (item === null || item === undefined) ? item : cb(item);
        if (!map.has(key)) {
            map.set(key, item);
            result.push(item);
        }
    });
    return result;
}
exports.uniqBy = uniqBy;
async function sleep(ms) {
    return new Promise((resolve) => setTimeout(resolve, ms));
}
exports.sleep = sleep;
function chunkList(array, size = 1) {
    const arrayChunks = [];
    for (let i = 0; i < array.length; i += size) {
        const arrayChunk = array.slice(i, i + size);
        arrayChunks.push(arrayChunk);
    }
    return arrayChunks;
}
exports.chunkList = chunkList;
