/// <reference types="node" />
import EventEmitter from "events";
import { ChunkId } from "../interface";
import { Row } from "../row";
import { Chunk } from "../chunk/chunk";
export interface LoadContract {
    loadedRows: Row[];
}
export interface SaveContract {
    chunkRef: Chunk;
    insertRows: Row[];
}
export interface DataWatcherOptions {
    chunkSize: number;
}
export declare abstract class DataWatcher<SC extends SaveContract = SaveContract, LC extends LoadContract = LoadContract, OP extends DataWatcherOptions = DataWatcherOptions> {
    #private;
    readonly $emitter: EventEmitter;
    readonly $options: OP;
    constructor(options: OP);
    $setWriteable(state: boolean): void;
    $isWriteable(): boolean;
    $toBeUnblocked(): Promise<void>;
    abstract save(storeContract: SC): Promise<void>;
    abstract load(chunkId: ChunkId): Promise<LC>;
    abstract backup(): void;
    abstract restore(): Promise<void>;
    abstract cleanup(chunkId: ChunkId): Promise<void>;
    abstract countRows(chunkId: ChunkId): number;
}
