import { DataWatcher, SaveContract, LoadContract, DataWatcherOptions } from "./abstract";
import { ChunkRegistry } from '../chunk-registry';
import { Chunk } from '../chunk/chunk';
export interface FsWatcherOptions extends DataWatcherOptions {
    disk: {
        outputDirectory: string;
    };
}
interface DiskLoadContract extends LoadContract {
    chunkRef: Chunk;
}
export declare class DiskWatcher extends DataWatcher<SaveContract, DiskLoadContract, FsWatcherOptions> {
    #private;
    constructor(registry: ChunkRegistry, options: FsWatcherOptions);
    save(saveContract: SaveContract): Promise<void>;
    load(chunkId: string): Promise<DiskLoadContract>;
    backup(): void;
    restore(): Promise<void>;
    cleanup(chunkId: string): Promise<void>;
    countRows(chunkId: string): number;
}
export {};
