"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ProcessWatcher_registry, _ProcessWatcher_chunkRows;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessWatcher = void 0;
const abstract_1 = require("./abstract");
class ProcessWatcher extends abstract_1.DataWatcher {
    constructor(registry, options) {
        super(options);
        _ProcessWatcher_registry.set(this, void 0);
        _ProcessWatcher_chunkRows.set(this, void 0);
        __classPrivateFieldSet(this, _ProcessWatcher_chunkRows, {}, "f");
        __classPrivateFieldSet(this, _ProcessWatcher_registry, registry, "f");
    }
    async save(saveContract) {
        if (!__classPrivateFieldGet(this, _ProcessWatcher_registry, "f").getOne(saveContract.chunkRef.id)) {
            __classPrivateFieldGet(this, _ProcessWatcher_registry, "f").register(saveContract.chunkRef);
        }
        if (!this.$isWriteable()) {
            await this.$toBeUnblocked();
        }
        if (!__classPrivateFieldGet(this, _ProcessWatcher_chunkRows, "f")[saveContract.chunkRef.id]) {
            __classPrivateFieldGet(this, _ProcessWatcher_chunkRows, "f")[saveContract.chunkRef.id] = [];
        }
        __classPrivateFieldGet(this, _ProcessWatcher_chunkRows, "f")[saveContract.chunkRef.id].push(...saveContract.insertRows.map(row => {
            return {
                chunkId: saveContract.chunkRef.id,
                table: saveContract.chunkRef.table,
                row
            };
        }));
        __classPrivateFieldGet(this, _ProcessWatcher_registry, "f").increaseSize(saveContract.chunkRef.id, saveContract.insertRows.length);
    }
    async load(chunkId) {
        const loadedRows = __classPrivateFieldGet(this, _ProcessWatcher_chunkRows, "f")[chunkId] ?? {};
        return {
            loadedRows
        };
    }
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    async cleanup() { }
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    backup() { }
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    async restore() { }
    countRows(chunkId) {
        return __classPrivateFieldGet(this, _ProcessWatcher_registry, "f").getOne(chunkId).size;
    }
}
exports.ProcessWatcher = ProcessWatcher;
_ProcessWatcher_registry = new WeakMap(), _ProcessWatcher_chunkRows = new WeakMap();
